<?php

/**
 * Description of run
 *
 * @author Artem Yuriev art3mk4@gmail.com Feb 15, 2019 10:23:12 AM
 */
if (!defined('ADSGOOGLECATALOG_PATH')) define('ADSGOOGLECATALOG_PATH', __DIR__);
if (!defined('ADSGOOGLECONFIG_PATH')) define('ADSGOOGLECONFIG_PATH', dirname(dirname(dirname(__DIR__))));
if (!defined('ABSPATH')) define ('ABSPATH', dirname(dirname(__DIR__)));
require_once 'progress/autoload.php';
$fileLoad = progress\models\ConfigGoogle::loadFile();
progress\models\Settings::init();
if ($fileLoad) {
    $process = new progress\models\Process();
    try {
        run_process($process, $argv[1]);
    } catch (Exception $exc) {
        echo $exc->getMessage();
    }
}

/**
 * run_process
 * 
 * @param type $process
 * @param type $params
 */
function run_process($process, $params) {
    parse_str($params, $stashParams);
    $product = progress\models\ProductFabrica::create($stashParams['woocommerce']);
    $stashParams['category'] = explode(', ', $stashParams['category']);
    $totalProducts = $product->getTotalProducts($stashParams['category']);
    $total = isset($totalProducts['count']) ? $totalProducts['count'] : 0;
    $page = 1;
    if (isset($stashParams['current_page'])) {
        $page = $stashParams['current_page'];
        $page++;
    }

    if ($page == 1) {
        progress\models\XmlGenerator::deleteXml();
        progress\models\XmlGenerator::generateHeader();
    }

    while ($total >= $page) {
        $product->findAll($page, $stashParams['category'], $stashParams['currency']);
        $progress = $page/$total * 100;
        $status = ($total == $page) ? \progress\models\Process::DONE : \progress\models\Process::INPROGRESS;
        $params = array(
            'progress'     => intval($progress),
            'total_page'   => $total,
            'current_page' => $page,
            'finish_time'  => date('Y-m-d H:i:s'),
            'status'       => $status
        );

        $process->update(
            $params,
            array(
                'pid' => getmypid()
            )
        );

        if ($status == \progress\models\Process::DONE) {
            $xmlDocument = $product->xmlGenerator;
            $xmlDocument::endDocument();
            $tempFile = \progress\models\XmlGenerator::getFilePath();
            $destinationFile = \progress\models\XmlGenerator::getCopyFilePath();
            $copyFile = copy($tempFile, $destinationFile);
        }

        $page++;
    }
    
    if ($total == 0) {
        $process->delete(
            array(
                'pid' => getmypid()
            )
        );
    }
}