<?php

namespace progress\models;
use progress\models\pdo\MysqlPDO as MysqlPDO;

/**
 * Description of GoogleAttributes
 *
 * @author Artem Yuriev art3mk4@gmail.com Feb 15, 2019 11:53:48 AM
 */
class GoogleAttributes extends MysqlPDO
{

    /**
     * GoogleAttributes
     */
    public function __construct()
    {
        $this->setTable('ads_google_attributes');
        parent::__construct();
    }

    /**
     * findByAttribute
     * 
     * @param type $attribute
     */
    public function findByAttribute($attribute = '')
    {
        $select = $this->prepare('SELECT value FROM ' . TABLE_PREFIX . $this->table . ' WHERE attribute = :attribute');
        $select->bindValue(':attribute', $attribute);
        $select->execute();
        $result = $select->fetchAll(\PDO::FETCH_ASSOC);
        if (!$result
            || !is_array($result)
        ) {
            return array();
        }

        $attributes = array();
        foreach ($result as $item) {
            if (isset($item['value'])) {
                $attributes[] = $item['value'];
            }
        }

        return $attributes;
    }
}