<?php

namespace progress\models;

/**
 * Description of GoogleProcess
 *
 * @author Artem Yuriev art3mk4@gmail.com Nov 30, 2018 10:32:48 AM
 */
class GoogleProcess
{

    const STDIN = 0;
    const STDOUT = 1;
    const STDERR = 2;

    /**
     * $descriptorspec
     * 
     * @var array 
     */
    public $descriptorspec = array(
        self::STDIN  => ['pipe', 'r'],
        //self::STDOUT => ['file', '/home/art3mk4/public_html/wp-content/plugins/adsgooglecatalog/output.txt', 'a'],
        self::STDOUT => ['pipe', 'w'],
        self::STDERR => ['pipe', 'w']
    );

    /**
     * $output
     * 
     * @var type 
     */
    public $output;

    /**
     * $_pipes
     * 
     * @var type 
     */
    private $_pipes = array();

    /**
     * $_handle
     * 
     * @var type 
     */
    protected $_handle;

    /**
     * $_status
     * 
     * @var type 
     */
    private $_status;

    /**
     *
     * @var type 
     */
    public $processModel;

    /**
     * FacebookProcess construct
     */
    public function __construct($params = '')
    {
        $this->processModel = new Process();
        $count = $this->processModel->count();
        if ($count != 0) {
            $process = $this->processModel->find();
            if (!isset($process['pid'])) {
                throw new \Exception('Process not found');
            }
            $pid = intval($process['pid']);
            if ($this->isActive($pid)) {
                $this->close($pid);
            }

            $this->processModel->delete(
                array(
                    'id' => $process['id']
                )
            );
        }

        $this->_handle = proc_open('exec php google_process.php ' . escapeshellarg($params), $this->descriptorspec, $this->_pipes, ADSGOOGLECATALOG_PATH);
        $this->status();
        $status = $this->getStatus();
        if (!$status['running']) {
            throw new \RuntimeException('Process failed to start: ' . stream_get_contents($this->_pipes[self::STDERR]));
        }
        $this->start($status['pid'], $params);
    }

    /**
     * start
     * 
     * @param type $pid
     * @param type $params
     */
    public function start($pid, $params)
    {
        $data = array(
            'pid'         => $pid,
            'progress'    => 0,
            'start_time'  => date('Y-m-d H:i:s'),
            'finish_time' => date('Y-m-d H:i:s'),
            'status'      => Process::INPROGRESS,
            'params'      => escapeshellarg($params)
        );

        $this->processModel->insert($data);
    }

    /**
     * count
     * 
     * @return type
     */
    public function count()
    {
        return $this->processModel->count();
    }

    /**
     * status
     */
    public function status()
    {
        $this->_status = proc_get_status($this->_handle);
    }

    /**
     * isActive
     * 
     * @param type $pid
     * @return type
     */
    public static function isActive($pid)
    {
        return (posix_getpgid($pid)) ? $pid : false;
    }

    /**
     * close
     */
    public function close($pid)
    {
        posix_kill($pid, 9);
    }

    /**
     * getHandle
     * 
     * @return type
     */
    public function getHandle()
    {
        return $this->_handle;
    }

    /**
     * getOutput
     * 
     * @return type
     */
    public function getOutput()
    {
        if (isset($this->_pipes[1])) {
            return stream_get_contents($this->_pipes[self::STDOUT]);
        }
    }

    /**
     * getStatus
     * 
     * @return type
     */
    public function getStatus()
    {
        return $this->_status;
    }
}