<?php

namespace progress\models;
use progress\models\pdo\MysqlPDO as MysqlPDO;

/**
 * Description of Post
 *
 * @author Artem Yuriev art3mk4@gmail.com Dec 6, 2018 10:36:41 AM
 */
class Post extends MysqlPDO
{

    /**
     * permalink_structure
     * 
     * @var type 
     */
    public $permalink_structure;

    /**
     * extra_permastructs
     * 
     * @var type 
     */
    public $extra_permastructs = array();

    /**
     * Post construct
     */
    public function __construct()
    {
        $settings = Settings::instance();
        $this->permalink_structure = $settings->getPermalinkStructure();
        $this->setTable('posts');
        parent::__construct();
    }

    /**
     * find
     * 
     * @param type $arguments
     * @param type $table
     * @return type
     */
    public function find($arguments = array(), $table = '')
    {
        return parent::find($arguments, $table);
    }

    /**
     * get_post_permalink
     * 
     * @param type $id
     * @param type $leavename
     * @param type $sample
     */
    public function get_post_permalink($id = 0, $leavename = false, $sample = false)
    {
        $post = $this->get_post($id);
        if (!$post) {
            return $post;
        }

	$post_link = $this->get_extra_permastruct($post['post_type']);
	$slug = $post['post_name'];
	$draft_or_pending = in_array($post['post_status'], array('draft', 'pending', 'auto-draft', 'future'));

	if (!empty($post_link)
            && (!$draft_or_pending || $sample)
        ) {
            if (!$leavename) {
                $post_link = str_replace("%{$post['post_type']}%", $slug, $post_link);
            }
            $post_link = $this->home_url($this->user_trailingslashit($post_link));
	}

        return $post_link;
    }

    /**
     * get_post
     * 
     * @param type $id
     * @return type
     */
    public function get_post($id)
    {
        $result = $this->find(array('id' => $id));
        return $result;
    }

    /**
     * get_extra_permastruct
     * 
     * @param type $type
     * @return boolean
     */
    public function get_extra_permastruct($type)
    {
        return 'product/%product%';
    }

    /**
     * home_url
     * 
     * @param type $url
     * @return type
     */
    public function home_url($url)
    {
        return ADS_FACEBOOK_SITEURL . '/' . $url;
    }

    /**
     * user_trailingslashit
     * 
     * @param type $string
     * @return type
     */
    public function user_trailingslashit($string)
    {
        return rtrim($string, '/\\') . '/';
    }
}