<?php

namespace progress\models;
use progress\models\pdo\MysqlPDO as MysqlPDO;

/**
 * Description of ShopConstant
 *
 * @author Artem Yuriev art3mk4@gmail.com Dec 5, 2018 10:26:57 AM
 */
class ShopConstant extends MysqlPDO
{

    /**
     * parseAgeGroup
     * 
     * @param type $param
     * @return string
     */
    public static function parseAgeGroup($param)
    {
        $params = self::ageGroupTable();
        if (in_array($param, array_keys($params))) {
            return $params[$param];
        }

        return 'adult';
    }

    /**
     * ageGroupTable
     * 
     * @return type
     */
    public static function ageGroupTable()
    {
        return array(
            'Adult'    => 'adult',
            'Children' => 'kids',
            'Babies'   => 'kids'
        );
    }

    /**
     * parseGender
     * 
     * @param type $param
     * @return string
     */
    public static function parseGender($param)
    {
        $params = self::genderTable();
        if (in_array($param, array_keys($params))) {
            return $params[$param];
        }

        return 'unisex';
    }

    /**
     * genderTable
     * 
     * @return type
     */
    public static function genderTable()
    {
        return array(
            'Men'   => 'male',
            'Women' => 'female'
        );
    }

    /**
     * sizeNames
     * 
     * @return array
     */
    public static function sizeNames()
    {
        $attribute = new GoogleAttributes();
        return $attribute->findByAttribute('size');
    }

    /**
     * colorNames
     * 
     * @return type
     */
    public static function colorNames()
    {
        $attribute = new GoogleAttributes();
        return $attribute->findByAttribute('color');
    }

    /**
     * typeNames
     * 
     * @return type
     */
    public static function typeNames()
    {
        $attribute = new GoogleAttributes();
        return $attribute->findByAttribute('type');
    }

    /**
     * modelNames
     * 
     * @return type
     */
    public static function modelNames()
    {
        $attribute = new GoogleAttributes();
        return $attribute->findByAttribute('model');
    }

    /**
     * variationNames
     * 
     * @return type
     */
    public static function variationNames()
    {
        $attribute = new GoogleAttributes();
        return $attribute->findByAttribute('variation');
    }

    /**
     * materialNames
     * 
     * @return type
     */
    public static function materialNames()
    {
        $attribute = new GoogleAttributes();
        return $attribute->findByAttribute('material');
    }
}